#include "stdafx.h"
#include "NominatimTestApp.h"
#include "cnominatim.h"


#pragma warning(suppress: 26485)
int _tmain(int /*argc*/, TCHAR* /*argv*/[], TCHAR* /*envp*/[]) //NOLINT(modernize-avoid-c-arrays)
{
  //Initialize COM
  HRESULT hr{CoInitialize(nullptr)};
  if (FAILED(hr))
  {
#pragma warning(suppress: 26472)
    _tprintf(_T("Fatal Error: Failed to initialize COM, Error:%08X\n"), static_cast<unsigned int>(hr));
    return 1;
  }

  //Do a search query using the example provided at http://wiki.openstreetmap.org/wiki/Nominatim
  Nominatim::CSearchQuery query;
#pragma warning(suppress: 26489)
  query.m_sQueryString = _T("135 pilkington avenue, birmingham");
  query.m_nLimit = 50;
#pragma warning(suppress: 26489)
  query.m_sUserAgent = _T("NominatimTestApp");
  query.m_bDedupe = false;
  Nominatim::CNominatim nominatim;
  std::vector<Nominatim::CSearchPlace> result;
#pragma warning(suppress: 26486)
  hr = nominatim.Search(query, result);
#pragma warning(suppress: 26477)
  ATLVERIFY(SUCCEEDED(hr));
  const auto nSize{result.size()};
#pragma warning(suppress: 26477)
  ATLVERIFY(nSize); //NOLINT(clang-diagnostic-unused-value)

  //Do reverse geocoding query using the details returned from the search above
  Nominatim::CReverseGeocodingQuery query2;
#pragma warning(suppress: 26446)
  query2.m_fLatitude = result[0].m_fLatitude;
#pragma warning(suppress: 26446)
  query2.m_fLongitude = result[0].m_fLongitude;
#pragma warning(suppress: 26489)
  query2.m_sUserAgent = _T("NominatimTestApp");
  query2.m_bExtraTags = true;
  query2.m_bNameDetails = true;
  Nominatim::CReverseGeocodingQueryResult result2;
#pragma warning(suppress: 26486)
  hr = nominatim.ReverseGeocoding(query2, result2);
#pragma warning(suppress: 26477)
  ATLVERIFY(SUCCEEDED(hr));

  //Do the address lookup query using the example provided at http://wiki.openstreetmap.org/wiki/Nominatim
  Nominatim::CAddressLookupQuery query3;
#pragma warning(suppress: 26489)
  query3.m_sOSMIds = _T("R146656,W104393803,N240109189");
  query3.m_bExtraTags = true;
  query3.m_bNameDetails = true;
#pragma warning(suppress: 26489)
  query3.m_sUserAgent = _T("NominatimTestApp");
  std::vector<Nominatim::CLookupPlace> result3;
#pragma warning(suppress: 26486)
  hr = nominatim.AddressLookup(query3, result3);
#pragma warning(suppress: 26477)
  ATLVERIFY(SUCCEEDED(hr));

  //Cleanup COM
  CoUninitialize();

  return 0;
}
